//
// BrackRec.cpp -     .
//      q-:
//
// 1. S -> (B)B
// 2. B -> (B)B
// 3. B -> empty
//

#include <iostream>
#include <string>
#include <vector>
#include <stack>

using namespace std;

string str;	//    ,   
int i;	//    

int erFlag; // ,      

// ,        .
//       .
//       Enter.
//  '\n'     .
void GetOneLine(istream &is, string &str) {
	char ch;
	str = "";
	for(;;) {
		is.get(ch);
		if(is.fail() || ch == '\n') break;
		str += ch;
	}
	str += '\n'; //   
}

// ,    B.
bool B() {
	if(str[i] == '(') {
		i++;
		if(B()) {
			if(str[i] == ')') {
				i++;
				if(B()) {
					//    ,
					//     .
					return true; 
				} else { //    B
					erFlag++;
					cout  << "Position " << i << ", "
						<< "Error 1: Incorrect last B!\n";
					return false;
				}
			} else { //   ')'
				erFlag++;
				cout  << "Position " << i << ", "
					<< "Error 2: I want \')\'!\n";
				return false;
			}
		} else {
			erFlag++;
			cout  << "Position " << i << ", "
				<< "Error 3: Incorrect first B!\n";
			return false;
		}
	} else	//   :
		return true; //   

}

// ,    S.
bool S() {
	if(str[i] == '(') {
		i++;
		if(B()) {
			if(str[i] == ')') {
				i++;
				if(B()) {
					if(str[i] == '\n') {
						return true; //    - 
					} else { //     
						erFlag++;
						cout  << "Position " << i << ", "
							<< "Error 4: I want string end after last right bracket!\n";
						return false;
					}
				} else {
					erFlag++;
					cout  << "Position " << i << ", "
						<< "Error 4: Incorrect last B!\n";
					return false;
				}
			} else {
				erFlag++;
				cout  << "Position " << i << ", "
					<< "Error 5: I want \')\'!\n";
				return false;
			}
		} else {
			erFlag++;
			cout  << "Position " << i << ", "
				<< "Error 6: Incorrect first B!\n";
			return false;
		}
	}
	return false; //    
		//   ,   
}

//        ,
//      
bool Parser() {
	//  .
	erFlag = 0;
	i = 0;

	//  !
	if(S()) 
		return true; //   
	else {
		if(erFlag)
			cout  << "Position " << i << ", "
				<< "Error 7: Internal Error!\n";
		else
			cout  << "Position " << i << ", "
				<< "Error 8: Incorrect first symbol of S!\n";
		return false; //  
	}
}

//        , 
//      
int main () {
	string strCursor;
	str = "";
	//     
	do {
		//      
		cout << "Input bracket\'s expression!: ";

		//      .
		GetOneLine(cin, str);

		//     .
		if(Parser())
			cout << "+++++ OK! +++++\n";
		else
			cout << "----- Fatal error (look upper error message)! -----\n";

		//        .
		cout << "Line: " << str;
		strCursor = " Pos: " + string(i, '-');
		strCursor +='^';
		cout << strCursor << "  i = " << i << "\n\n";

	} while(str != "\n");
	cout << "Goodbye!\n";
	return 1;
}